/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.c

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */

#include "config.h"
// threading library
#include "plib.h"
// config.h sets 40 MHz
#define	SYS_FREQ 40000000
#include "pt_cornell_1_2.h"
#include "xc.h"
#include <stdlib.h>
#include "config.h"
#include "tft_master.h"
#include "tft_gfx.h"

#include "biscuit_central.h"

#define PLAYER1 0x0000

//uint8_t player1_address[6] = {0x23, 0x11, 0x7B, 0x4C, 0x99, 0xB4}; // Red Bear

uint8_t green_address[6] = {0x74, 0x03, 0x7B, 0x4C, 0x99, 0xB4};
uint8_t blue_address[6] = {0x10, 0x0E, 0x7B, 0x4C, 0x99, 0xB4};
uint8_t yellow_address[6] = {0x6A, 0x03, 0x7B, 0x4C, 0x99, 0xB4};
uint8_t orange_address[6] = {0x6E, 0x19, 0x7B, 0x4C, 0x99, 0xB4};

int target_address = 99;
int sender_address = 99;
char command = 'x';
int value = 0;

//identification variables
uint32_t playerID = 1;

static struct pt pt_read, pt_input;
int loc;
int x, y, z;;

char buffer[30];
char rsrc, rdest, rdir;

uint8_t writeBuf[4];
// === UART Read Thread =================================================
// Reads a String from the UART channel into a buffer then Changes state accordingly
static PT_THREAD (protothread_read(struct pt *pt)) {
    PT_BEGIN(pt);
    
    //Clear the reset on the chip
    PT_YIELD_TIME_msec(50) ;
    mPORTAClearBits(BIT_4);
    
        while(1) {
            PT_YIELD_TIME_msec(50) ;
            
            PT_SPAWN(pt, &pt_input, PT_GetSerialBuffer(&pt_input) );
            
            // scans UART terminal for specified format
            rsrc = '?';
            rdest = '?';
            rdir = '?';
//            x = 0;
            
//            target_address = 99;
//            sender_address = 99;
//            command = 'x';
//            value = 0;
            
//            sscanf( PT_term_buffer, "%s %s %s", &rsrc, &rdest ,&rdir);
            sscanf( PT_term_buffer, "%c %c %c", &rsrc, &rdest, &rdir);
            
//            target_address = 99;
//            sender_address = 99;
//            command = '?';
//            value = 0;
//            sscanf( PT_term_buffer, "%i %i %c %i", &target_address, 
//                    &sender_address ,&command, &value );
            
//            printf("Player %i Found <%i> <%i> <%c> <%i> \r", playerID,target_address, sender_address ,command, value); //reprints when entered
            
            sprintf(buffer, "%c %c %c", rsrc, rdest ,rdir);
//            sprintf(buffer, "%i %i %c %i", target_address, 
//                    sender_address, command, value);
            
            tft_writeString(buffer);
            tft_setCursor(0, loc);
            loc+=10;
            
//            sprintf( writeBuf, "good" ); PT_YIELD_TIME_msec(500);
//            biscuit_central_write_bytes(PLAYER1, writeBuf, sizeof(writeBuf));
            
//            char g[7];// = 'good';
//            PT_YIELD_TIME_msec(250);
//            sprintf(PT_send_buffer, "%s", "$");
//            
////            uint8 i;
////            for (i=0; i<7; i++) {
////                printf("%c", g[i]);
////            }
//            
////            PT_send_buffer = &g;
//            PT_SPAWN(pt, &pt_input, PutSerialBuffer(&pt_input) );
            
//            clrUARTRxBuffer(UART2);
            
            // sets state based on input
//            if(target_address == playerID){
//            }
            // NEVER exit while
        } // END WHILE(1)
    PT_END(pt);
} //  thread

//delays durin init
void delay( unsigned t)
{ //uses internal timer 2
    T2CON = 0x8000;     // enable tmr1, Tcy, 1:1
    while (t--)
    {
        TMR2 = 0;
       // while (TMR1<8000);
        while( TMR2< 8000);

    }
}


// === Main  ======================================================
void main(void) {
//    SYSTEMConfigPerformance(PBCLK);

    ANSELA = 0; ANSELB = 0; CM1CON = 0; CM2CON = 0;


    // === config threads ==========
    // turns OFF UART support and debugger pin
    PT_setup();

//    init();
    // === setup system wide interrupts  ========
    INTEnableSystemMultiVectoredInt();
    
    mPORTASetPinsDigitalOut(BIT_4);
    
    mPORTASetBits(BIT_4);
    delay(2500);
    mPORTAClearBits(BIT_4);
    delay(2500);
    // set up BLE chip
//    biscuit_central_init();
//    delay(5000);
//    biscuit_central_connect(player1_address);
    // init the threads
    
    
    PT_INIT(&pt_read); 
    PT_INIT(&pt_input);
    
//    initialize screen
    tft_init_hw();
    tft_begin();
    tft_setRotation(1);
    tft_fillScreen(ILI9341_BLACK);
    tft_setCursor(0, 0);
    tft_setTextSize(1);
    tft_setTextColor(ILI9341_WHITE);
    
//    tft_writeString("Hello world!");
    
    // round-robin scheduler for threads
    while (1){
        PT_SCHEDULE(protothread_read(&pt_read));
    }
  } // main
/* *****************************************************************************
 End of File
 */
